﻿var VerifyCellType = (function (_super) {
    __extends(VerifyCellType, _super);
    function VerifyCellType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VerifyCellType.prototype.VerifyValue;
    VerifyCellType.prototype.createContent = function () {
        var self = this;
        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var container = $("<div id='" + this.ID + "'></div>");
        var innerContainer = $("<div id=" + this.ID + '_verify' + "></div>");
        container.append(innerContainer);
        return container;
    };

    VerifyCellType.prototype.getValueFromElement = function () {
        return this.VerifyValue;
    };

    VerifyCellType.prototype.setValueToElement = function (element, value) {

    };
    VerifyCellType.prototype.onLoad = function () {
        var self = this;
        var info = this.getVerifyCellTypeClass()
        if (info.type === 1) {
            $("#" + this.ID + "_verify").codeVerify({
                type: 1,
                width: info.width+'px',
                height: info.height+'px',
                fontSize: info.size +'px',
                codeLength: info.length,                
                ready: function () {
                },
                success: function () {
                    self.VerifyValue = 1;
                    self.commitValue();
                },
                error: function () {
                    self.VerifyValue = 0;
                    self.commitValue();
                }
            });
        }
        if (info.type === 2) {
            $("#" + this.ID + "_verify").codeVerify({
                type: 2,
                figure: info.pronumclass,	//位数，仅在type=2时生效
                arith: 0,	//算法，支持加减乘，不填为随机，仅在type=2时生效
                width: info.width + 'px',
                height: info.height + 'px',
                fontSize: info.size + 'px',
                //btnId: 'check-btn2',
                ready: function () {
                },
                success: function () { 
                    self.VerifyValue = 1;
                    self.commitValue();
                },
                error: function () {
                    self.VerifyValue = 0;
                    self.commitValue();                    
                }
            });
        }
        if (info.type === 3) {
            $("#" + this.ID + "_verify").slideVerify({
                type: 1,		//类型
                vOffset: info.offset,	//误差量，根据需求自行调整                
                barSize: {
                    width: info.width-3 + 'px',
                    height: info.height-3 + 'px',
                },
                ready: function () {
                },
                success: function () {
                    self.VerifyValue = 1; 
                    self.commitValue();
                },
                error: function () {
                    self.VerifyValue = 0;
                    self.commitValue();
                }

            });
        }
        if (info.type === 4) {
            $("#" + this.ID + "_verify").slideVerify({
                type: 2,		//类型
                vOffset: info.offset,	//误差量，根据需求自行调整
                vSpace: 5,	//间隔
                imgName: ['1.jpg', '2.jpg', '3.jpg', '4.jpg', '5.jpg', '6.jpg'],
                imgSize: {
                    width: info.width + 'px',
                    height: info.height*0.85 + 'px',
                },
                blockSize: {
                    width: info.height * 0.15 + 'px',
                    height: info.height * 0.15 + 'px',
                },
                barSize: {
                    width: info.width-3 + 'px',
                    height: info.height * 0.15-3 + 'px',
                },
                ready: function () {
                },
                success: function () {
                    self.VerifyValue = 1;
                    self.commitValue();
                },
                error: function () {
                    self.VerifyValue = 0;
                    self.commitValue();
                }

            });
        }
        if (info.type === 5) {
            $("#" + this.ID + "_verify").pointsVerify({
                defaultNum: info.cnum,	//默认的文字数量
                checkNum: info.ccnum,	//校对的文字数量
                vSpace: 5,	//间隔
                imgName: ['1.jpg', '2.jpg', '3.jpg', '4.jpg', '5.jpg', '6.jpg'],
                imgSize: {
                    width: info.width + 'px',
                    height: info.height*0.85 + 'px',
                },
                barSize: {
                    width: info.width -3+ 'px',
                    height: info.height * 0.15-3 + 'px',
                },
                ready: function () {
                },
                success: function () {
                    self.VerifyValue = 1;
                    self.commitValue();
                },
                error: function () {
                    self.VerifyValue = 0;
                    self.commitValue();
                }

            });
        }
    };


    //自定义的方法
    VerifyCellType.prototype.getVerifyCellTypeClass = function () {
        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var type = 1;
        var length = 6;
        var size = 30;
        var offset = 5;
        var cnum = 4;
        var ccnum = 2;
        var pronumclass = 10;
        if (cellTypeMetaData.ProTypeClass === ProTypeEnum.Enum0) {
            type = 1;
            length = cellTypeMetaData.Length;
            size = cellTypeMetaData.Size;
        }
        if (cellTypeMetaData.ProTypeClass === ProTypeEnum.Enum1) {
            type = 2;
            if (cellTypeMetaData.ProNumClass === ProNumEnum.Enumn1) {
                pronumclass = 10;
            }
            if (cellTypeMetaData.ProNumClass === ProNumEnum.Enumn2) {
                pronumclass = 100;
            }
            size = cellTypeMetaData.Size;
        }
        if (cellTypeMetaData.ProTypeClass === ProTypeEnum.Enum2) {
            type = 3;
            offset = cellTypeMetaData.Offset;
        }
        if (cellTypeMetaData.ProTypeClass === ProTypeEnum.Enum3) {
            type = 4;
            offset = cellTypeMetaData.Offset;
        }
        if (cellTypeMetaData.ProTypeClass === ProTypeEnum.Enum4) {
            type = 5;
            cnum = cellTypeMetaData.CNum;
            ccnum = cellTypeMetaData.CCNum;
        }
        return {
            width: element.Width,
            height: element.Height,
            type: type,
            length: length,
            size: size,
            offset: offset,
            cnum: cnum,
            ccnum: ccnum,
            pronumclass: pronumclass
        };
    };

    VerifyCellType.prototype.disable = function () {
        _super.prototype.disable.call(this);
    };

    VerifyCellType.prototype.enable = function () {
        _super.prototype.enable.call(this);
    };

    return VerifyCellType;
}(Forguncy.CellTypeBase));
var ProTypeEnum = {
    Enum0: 0,
    Enum1: 1,
    Enum2: 2,
    Enum3: 3,
    Enum4: 4
};
var ProNumEnum = {
    Enumn1: 0,
    Enumn2: 1 
};

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.Plugin.CellTypeHelper.registerCellType("VerifyCellType.VerifyCellType, VerifyCellType", VerifyCellType);